using System;
using System.Collections.Generic;
using System.Text;
using JetBrains.ReSharper.Daemon;
using JetBrains.ReSharper.Daemon.CSharp.Stages;
using JetBrains.ReSharper.Psi.CSharp;
using JetBrains.ReSharper.Util;

namespace ExitPointsHighlighter
{
    [DaemonStage]
    class ExitPointsHighligherStage : CSharpDaemonStageBase
    {
        public static readonly Key KEY;

        static ExitPointsHighligherStage()
        {
            ExitPointsHighligherStage.KEY = new Key("ExitPointsHighlighter.ExitPointsHighligherStage");
        }
 
        public override IDaemonStageProcess CreateProcess(IDaemonProcess process)
        {
            if (!base.IsSupported(process))
            {
                return null;
            }
            return new ExitPointsHighligherStageProcess(process);

        }

        public override Key Key
        {
            get { return ExitPointsHighligherStage.KEY; }
        }

        public override Key[] StagesBefore
        {
            get { return new Key[] { SmartResolverStage.KEY }; }
        }

        public override Key[] StagesAfter
        { 
             get { return new Key[] { GlobalIdentifierHighlighterStage.KEY }; }
        }

        public override bool CanProduceErrors
        {
            get { return false; }
        }
    }
}
